#!/usr/bin/python
"""
function: this code is used to enable the output of detailed motif combinations file (4.3 in readme.txt)
usage: python detailed_motif_combiantions.py <motif_combinations><TFBS information><motif><seqs><output format: txt, xls>
"""
import pdb,sys,os

#read in motif_combinations----------------------
f=open(sys.argv[1],'r')

dt={}
#read in TBFS information------------------------
g=open(sys.argv[2],'r')
lg=g.readlines()
g.close()
lg=[item.strip() for item in lg]
lg=[item.split('\t') for item in lg]
for i in range(len(lg)):
	dt[lg[i][0][1:]]=i

#read in motif------------------------------------
fm=open(sys.argv[3],'r')
lfm=fm.readlines()
fm.close()
lfm=''.join(lfm)
lfm=lfm.split('>')[1:]
lfm=[item.split('\n')[:-2] for item in lfm]
motifs=[]
moid=[]
dm={}
for i in range(len(lfm)):
	t=lfm[i][1:]
	t=[item.split(' ') for item in t]
	motifs.append(t)
	mid=lfm[i][0].split('\t')[0]
	moid.append(mid)
	dm[mid]=i


#read in seqs-------------------------------------
fs=open(sys.argv[4],'r')
lfs=fs.readlines()
fs.close()
lfs=''.join(lfs)
lfs=lfs.split('>')[1:]
lfs=[item.split('\n') for item in lfs]
lfs=[[item[0],''.join(item[1:-1])] for item in lfs]


#read in output format-------------------------------
fmt=sys.argv[5]

ct=0
out=open(sys.argv[4]+'.dmc'+'.'+fmt,'a')
for line in f:
	if ct>0:
		line=line.strip()
		line=line.split('\t')
		mc=line[1].split(' ')[:-1]
		for i in range(len(mc)):
			mc[i]=mc[i].split('(')[0]
		#pdb.set_trace()
		target=line[-1].split(',')
		line_result='\t'.join(line[:-1])
		for i in target:
			tfbs_i=lg[dt[i]][1].split(' ')
			tfbsl_i=lg[dt[i]][2].split(' ')
			i_result=i+'\t'
			for j in mc:
				index_j_list=[k for k in range(len(tfbs_i)) if tfbs_i[k]==j]
				j_result='['+j+']'
				for index_j in index_j_list:
					j_seq=lfs[dt[i]-1][1][int(tfbsl_i[index_j]):int(tfbsl_i[index_j])+len(motifs[dm[j]])]
					j_result=j_result+j_seq+'('+tfbsl_i[index_j]+')'
					#pdb.set_trace()
				i_result=i_result+' '+j_result
			line_result=line_result+'\n'+i_result
		out.write(line_result+'\n')
	ct+=1	
	print(ct)	
out.close()
f.close()

