#!/usr/bin/env python
"""
author: jun ding
date: 09/29/2013
function: this code is used to output the motif TBFS file
usage: python get_tfbs.py <.hits> <.pos> <seq><motif><outputdir>
"""
########################################################################
import pdb,sys,os
#########################################################################
# read in .hits

f=open(sys.argv[1],'r')
lf=f.readlines()
f.close()
lf=[item.strip() for item in lf]
lf=[item.split() for item in lf]
hit=lf

#######################################################################
# read in .pos
f=open(sys.argv[2],'r')
lf=f.readlines()
f.close()
lf=[item.strip() for item in lf]
lf=[item.split() for item in lf]
pos=lf

########################################################################
# read in the sequence
f=open(sys.argv[3],'r')
lf=f.readlines()
lf="".join(lf)
lf=lf.split(">")[1:]
lf=[item.split("\n") for item in lf]
for i in range(len(lf)):
	lf[i]=[item.strip() for item in lf[i]]
	lf[i]=[lf[i][0],"".join(lf[i][1:]).strip()]
seq=lf

########################################################################
# read in motifs
# read in the sequence
f=open(sys.argv[4],'r')
lf=f.readlines()
lf="".join(lf)
lf=lf.split(">")[1:]
TMot=[item[:] for item in lf]
lf=[item.split("\n") for item in lf]
dl={}
for i in range(len(lf)):
	lf[i]=[item.strip() for item in lf[i]]
	lf[i][0]=lf[i][0].split("\t")[0]
	dl[lf[i][0][1:]]=len(lf[i])-1
motif=lf


#pdb.set_trace()
######################################################################
dm={}
for i in range(len(hit)):
	for j in range(len(hit[i])):
		if hit[i][j] not in dm:
			dm[hit[i][j]]=str(i)+","+pos[i][j]
		else:
			dm[hit[i][j]]+=";"+str(i)+","+pos[i][j]

K=dm.keys()
K=[int(item) for item in K]
K.sort()
K=[str(item) for item in K]
out=[]
outm=[]
for i in K:
	DK=dm[i]
	DK=DK.split(";")
	outi=[]
	x=dl[str(i)]
	for j in DK:
		j=j.split(",")
		outi.append("M"+str(i)+","+seq[int(j[0])][0]+","+j[1]+"\t"+seq[int(j[0])][1][int(j[1]):int(j[1])+x])
	outi="\n".join(outi)
	out.append(">M"+str(i)+":\n"+outi)
	outm.append(TMot[int(i)])
out="\n".join(out)
outdir=sys.argv[5]
fn=sys.argv[3].split("/")[-1]
f=open("%s/%s.tfbs.adjusted"%(outdir,fn),'w')
f.write(out)
f.close()

outm=[">"+item for item in outm]
outm=''.join(outm)
f=open(sys.argv[4],'w')
f.write(outm)
f.close()


