#!/usr/bin/env python
"""
author: jun ding
date: 03/20/2014
function: this code is used to get the tfbs in motif modules

python tfbs_mc.py <non_hit> <non_pos> <mc> <outputdir>
"""
import pdb,sys,os


###########################################################################
def readFile(fname):
	f=open(fname,'r')
	lf=f.readlines()
	f.close()
	lf=[item.strip().split() for item in lf]
	return lf
	
def getmcTarget(A,dm):
	A=[item[1] for item in A]
	t0=dm[A[0]]
	for i in range(0,len(A)):
		ti=dm[A[i]]
		t0=[item for item in t0 if item in ti]
	return t0
	
def readFile(fname):
	f=open(fname,'r')
	lf=f.readlines()
	f.close()
	lf=[item.strip().split() for item in lf]
	return lf


def readSeq(fname):
	f=open(fname,'r')
	lf=f.readlines()
	f.close()
	lf="".join(lf)
	lf=lf.split(">")[1:]
	for i in range(len(lf)):
		lf[i]=lf[i].split("\n")
		lf[i]=[item.strip() for item in lf[i]]
		lf[i]=[lf[i][0],"".join(lf[i][1:])]

	return lf
		
def readMot(fname):
	f=open(fname,'r')
	lf=f.readlines()
	f.close()
	lf="".join(lf)
	lf=lf.split(">")[1:]
	lf=[item.split("\n") for item in lf]
	for i in range(len(lf)):
		lf[i][0]=lf[i][0].split("\t")[0][1:]
		lf[i]=[item for item in lf[i] if item!=""]
	return lf
		
#########################################################################
# read in hit

hit=readFile(sys.argv[1])
pos=readFile(sys.argv[2])


dm={}
dmt={}
for i in range(len(hit)):
	for j in range(len(hit[i])):
		mi=hit[i][j]
		if mi not in dm:
			dm[mi]=[i]
			dmt[mi]=str(i)+","+pos[i][j]
		else:
			dm[mi]=list(set(dm[mi]+[i]))
			dmt[mi]=dmt[mi]+";"+str(i)+","+pos[i][j]
	print(i)

dmc={}

#pdb.set_trace()
f=open(sys.argv[3],'r')
ct=0
for line in f:
	line=line.strip().split()[:-2] 
	line=[item[1:] for item in line]
	for j in line:
		if dmc.has_key(j)==False:
			dmc[j]=[line]
		else:
			dmc[j].append(line)
		
	ct+=1
	print(ct)
	
############################################################################
ct=0
FN=sys.argv[3].split("/")[-1]
seq=readSeq(sys.argv[4])
mot=readMot(sys.argv[5])
dmot={}
for i in mot:
	dmot[i[0]]=len(i)-1

outputdir=sys.argv[6]
if os.path.exists(outputdir)==False:
	os.mkdir(outputdir)
g=open(outputdir+"/"+FN+".tfbs.inModule",'a')

########################################################################

K=dmc.keys()
K=[int(item) for item in K]
K.sort()
K=[str(item) for item in K]
for i in K:
	co=dmc[i]
	ti=dmt[i]
	ti=ti.split(";")
	t=[]
	for j in ti:
		j_ind=int(j.split(",")[0])
		jp=j.split(",")[1]
		hj=hit[j_ind]
		for k in co:
			ov=[item for item in k if item in hj]
			if len(ov)==len(k):
				jtn=seq[j_ind][0]
				jts=seq[j_ind][1][int(jp):int(jp)+dmot[str(i)]]
				t.append("M"+str(i)+","+jtn+","+str(jp)+"\t"+jts)
				break
	ct+=1
	t="\n".join(t)
	print(ct)
	g.write(">M"+str(i)+"\n"+t+"\n")
g.close()

			
			


